<?php
namespace app\web\controller;

use think\facade\Session;
use app\web\BaseController;
use app\common\model\Worker as WorkerModel;
use app\common\model\User as UserModel;
use app\common\model\UserFollow as UserFollowModel;
use app\common\model\UserGroups as UserGroupsModel;
use app\common\model\UserAuths as UserAuthsModel;
use app\common\model\Comjobs as ComjobsModel;
use app\common\model\ComjobsCate as ComjobsCateModel;
use app\common\model\ComjobsLog as ComjobsLogModel;

class Comjobs extends BaseController
{
	
	
	public function setLog()
	{
		$ret = array('status'=>"error", 'msg'=>"error", 'mobile'=>"");
		$comjobsid = input('comjobsid/d', 0); 
		$comjobs = ComjobsModel::where('status','in','3,4')->where('id','=',$comjobsid)->findOrEmpty();
		if ($comjobs->isEmpty()){
			$ret['msg'] = "招聘信息不存在。";
			exit(json_encode($ret));
		}
		$mobile = input('mobile/s', "");
		if (empty($mobile)){
			$ret['msg'] = "报名手机号不能为空。";
			exit(json_encode($ret));
		}
		$user = UserModel::where(['mobile'=>$mobile])->findOrEmpty();
		if ($user->isEmpty()){
			$groups = UserGroupsModel::order(['isdefault'=>'desc','id'=>'asc'])->findOrEmpty();
			$user = new UserModel;
			$user->save([
				'groupsid'			=> $groups->isEmpty() ? 0 : $groups->id,
				'brokerid'			=> 0,
				'nickname'			=> "昵称",
				'avatar'			=> "",
				'realname'			=> "姓名",
				'mobile'			=> $mobile,
				'integral'			=> 0,
				'inttotal'			=> 0,
				'status'			=> 2,
				'isvip'				=> 1,
				'authstatus'		=> 1,
				'authremark'		=> "",
				'idcardzpic'		=> "",
				'idcardfpic'		=> "",
				'idcard'			=> "",
				'gender'			=> 1,
				'birthday'			=> "",
				'address'			=> "",
				'education'			=> "",
				'createtime'		=> time(),
				'jobintention'		=> "",
				'workexperience'	=> "",
				'eduexperience'		=> "",
				'followstatus'		=> 1,
				'wxampcode'			=> "",
				'bankcard'			=> array('openbank'=>"",'account'=>"",'number'=>"")
			]);
			$userauths = new UserAuthsModel();
			$userauths->save([
				'userid'		=> $user->id,
				'identitytype'	=> "mobile",
				'identifier'	=> $mobile,
				'password'		=> md5(time().mt_rand(100000, 999999)),
				'logintime'		=> time(),
				'loginip'		=> $_SERVER['SERVER_ADDR']
			]);
		}
		session('usermobile', $mobile);
		$log = ComjobsLogModel::where(['comjobsid'=>$comjobsid,'userid'=>$user->id])->findOrEmpty();
		if ($log->isEmpty()){
			$log->save([
				'workerid' 		=> $comjobs->workerid,
				'comjobsid'		=> $comjobsid,
				'userid'		=> $user->id,
				'status'		=> 1,
				'remark'		=> "",
				'createtime'	=> time()
			]);
			UserFollowModel::create([
				'userid'		=> $user->id,
				'ftype'			=> "招聘报名",
				'fstatus'		=> 1,
				'remark'		=> $comjobs->title,
				'createtime'	=> time()
			]);
			$ret['status'] = "success";
			$ret['msg'] = "报名成功，我们会尽快为你安排面试。";
			$ret['mobile'] = $mobile;
			echo json_encode($ret);
		}else{
			$ret['status'] = "success";
			$ret['msg'] = "你已报名过了，无需重复报名。";
			$ret['mobile'] = $mobile;
			echo json_encode($ret);
		}
	}
	
	
	public function detail()
	{
		$comjobsid = input('comjobsid/d', 0); 
		$comjobs = ComjobsModel::with(['worker','comjobsCate'])->where('status','in','3,4')->where('id','=',$comjobsid)->findOrEmpty();
		if (!$comjobs->isEmpty()){
			$comjobs->volume	+=  1;
			$comjobs->save();
		}
		$comjobslist = ComjobsModel::with(['worker','comjobsCate'])->where(['status'=>3,'workerid'=>$comjobs->workerid])->where('createtime','<=',time())->order(['updatetime'=>'desc','createtime'=>'desc','id'=>'desc'])->limit(5)->select();
		return view('comjobs/detail', [
			'comjobs'		=> $comjobs,
			'comjobslist'	=> $comjobslist,
			'usermobile'	=> session('?usermobile') ? session('usermobile') : ""
		]);
	}
	
	
	public function comjobs()
	{
		$addressarr = array('不限'=>['不限']);
		$addressarr['北京市'] = ['不限', '朝阳区', '海淀区', '通州区', '房山区', '丰台区', '昌平区', '大兴区', '顺义区', '西城区', '延庆县', '石景山区', '宣武区', '怀柔区', '崇文区', '密云县', '东城区', '平谷区', '门头沟区'];
		$addressarr['广东省'] = ['不限', '东莞市', '广州市', '中山市', '深圳市', '惠州市', '江门市', '珠海市', '汕头市', '佛山市', '湛江市', '河源市', '肇庆市', '清远市', '潮州市', '韶关市', '揭阳市', '阳江市', '梅州市', '云浮市', '茂名市', '汕尾市'];
		$addressarr['山东省'] = ['不限', '济南市', '青岛市', '临沂市', '济宁市', '菏泽市', '烟台市', '淄博市', '泰安市', '潍坊市', '日照市', '威海市', '滨州市', '东营市', '聊城市', '德州市', '莱芜市', '枣庄市'];
		$addressarr['江苏省'] = ['不限', '苏州市', '徐州市', '盐城市', '无锡市', '南京市', '南通市', '连云港市', '常州市', '镇江市', '扬州市', '淮安市', '泰州市', '宿迁市'];
		$addressarr['河南省'] = ['不限', '郑州市', '南阳市', '新乡市', '安阳市', '洛阳市', '信阳市', '平顶山市', '周口市', '商丘市', '开封市', '焦作市', '驻马店市', '濮阳市', '三门峡市', '漯河市', '许昌市', '鹤壁市', '济源市'];
		$addressarr['上海市'] = ['不限', '松江区', '宝山区', '金山区', '嘉定区', '南汇区', '青浦区', '浦东新区', '奉贤区', '徐汇区', '静安区', '闵行区', '黄浦区', '杨浦区', '虹口区', '普陀区', '闸北区', '长宁区', '崇明区', '卢湾区'];
		$addressarr['河北省'] = ['不限', '石家庄市', '唐山市', '保定市', '邯郸市', '邢台市', '河北区', '沧州市', '秦皇岛市', '张家口市', '衡水市', '廊坊市', '承德市'];
		$addressarr['浙江'] = ['不限', '温州市', '宁波市', '杭州市', '台州市', '嘉兴市', '金华市', '湖州市', '绍兴市', '舟山市', '丽水市', '衢州市'];
		$addressarr['香港特别行政区'] = ['不限', '香港岛', '九龙', '新界'];
		$addressarr['陕西省'] = ['不限', '西安市', '咸阳市', '宝鸡市', '汉中市', '渭南市', '安康市', '榆林市', '商洛市', '延安市', '铜川市'];
		$addressarr['湖南省'] = ['不限', '长沙市', '邵阳市', '常德市', '衡阳市', '株洲市', '湘潭市', '永州市', '岳阳市', '怀安市', '郴州市', '娄底市', '益阳市', '张家界市', '湘西州'];
		$addressarr['重庆市'] = ['不限', '江北区', '渝北区', '沙坪坝区', '九龙坡区', '万州区', '永川区', '南岸区', '酉阳县', '北碚区', '涪陵区', '秀山县', '巴南区', '渝中区', '石柱县', '忠县', '合川市', '大渡口区', '开县', '长寿区', '荣昌县', '云阳县', '梁平县', '潼南县', '江津市', '彭水县', '綦江县', '璧山县', '黔江区', '大足县', '巫山县', '巫溪县', '垫江县', '丰都县', '武隆县', '万盛区', '铜梁县', '南川市', '奉节县', '双桥区', '城口县'];
		$addressarr['福建省'] = ['不限', '漳州市', '厦门市', '泉州市', '福州市', '莆田市', '宁德市', '三明市', '南平市', '龙岩市'];
		$addressarr['天津市'] = ['不限', '和平区', '北辰区', '河北区', '河西区', '西青区', '津南区', '东丽区', '武清区', '宝坻区', '红桥区', '大港区', '汉沽区', '静海县', '塘沽区', '宁河县', '蓟县', '南开区', '河东区'];
		$addressarr['云南省'] = ['不限', '昆明市', '红河州', '大理州', '文山州', '德宏州', '曲靖市', '昭通市', '楚雄州', '保山市', '玉溪市', '丽江地区', '临沧地区', '思茅地区', '西双版纳州', '怒江州', '迪庆州'];
		$addressarr['四川省'] = ['不限', '成都市', '绵阳市', '广元市', '达州市', '南充市', '德阳市', '广安市', '阿坝州', '巴中市', '遂宁市', '内江市', '凉山州', '攀枝花市', '乐山市', '自贡市', '泸州市', '雅安市', '宜宾市', '资阳市', '眉山市', '甘孜州'];
		$addressarr['广西壮族自治区'] = ['不限', '贵港市', '玉林市', '北海市', '南宁市', '柳州市', '桂林市', '梧州市', '钦州市', '来宾市', '河池市', '百色市', '贺州市', '防城港市'];
		$addressarr['安徽省'] = ['不限', '芜湖市', '合肥市', '六安市', '宿州市', '阜阳市', '安庆市', '马鞍山市', '蚌埠市', '淮北市', '淮南市', '宣城市', '黄山市', '铜陵市', '亳州市', '池州市', '巢湖市', '滁州市'];
		$addressarr['海南省'] = ['不限', '三亚市', '海口市', '琼海市', '文昌市', '东方市', '昌江县', '陵水县', '乐东县', '保亭县', '五指山市', '澄迈县', '万宁市', '儋州市', '临高县', '白沙县', '定安县', '琼中县', '屯昌县'];
		$addressarr['江西省'] = ['不限', '南昌市', '赣州市', '上饶市', '吉安市', '九江市', '新余市', '抚州市', '宜春市', '景德镇市', '萍乡市', '鹰潭市'];
		$addressarr['湖北省'] = ['不限', '武汉市', '宜昌市', '襄樊市', '荆州市', '恩施州', '黄冈市', '孝感市', '十堰市', '咸宁市', '黄石市', '仙桃市', '天门市', '随州市', '荆门市', '潜江市', '鄂州市', '神农架林区'];
		$addressarr['山西省'] = ['不限', '太原市', '大同市', '运城市', '长治市', '晋城市', '忻州市', '临汾市', '吕梁市', '晋中市', '阳泉市', '宿州市'];
		$addressarr['辽宁省'] = ['不限', '大连市', '沈阳市', '丹东市', '辽阳市', '葫芦岛市', '锦州市', '朝阳市', '营口市', '鞍山市', '抚顺市', '阜新市', '盘锦市', '本溪市', '铁岭市'];
		$addressarr['台湾省'] = ['不限', '台北市', '高雄市', '台中市', '新竹市', '基隆市', '台南市', '嘉义市'];
		$addressarr['黑龙江'] = ['不限', '齐齐哈尔市', '哈尔滨市', '大庆市', '佳木斯市', '双鸭山市', '牡丹江市', '鸡西市', '黑河市', '绥化市', '鹤岗市', '伊春市', '大兴安岭地区', '七台河市'];
		$addressarr['内蒙古自治区'] = ['不限', '赤峰市', '包头市', '通辽市', '呼和浩特市', '鄂尔多斯市', '乌海市', '呼伦贝尔市', '兴安盟', '巴彦淖尔盟', '锡林郭勒盟', '阿拉善盟', '大兴安岭地区', '七台河市'];
		$addressarr['澳门特别行政区'] = ['不限', '澳门半岛', '离岛'];
		$addressarr['贵州省'] = ['不限', '贵阳市', '黔东南州', '黔南州', '遵义市', '黔西南州', '毕节地区', '铜仁地区', '安顺市', '六盘水市'];
		$addressarr['甘肃省'] = ['不限', '兰州市', '天水市', '庆阳市', '武威市', '酒泉市', '张掖市', '陇南地区', '白银市', '定西地区', '平凉市', '嘉峪关市', '临夏回族自治州', '金昌市', '甘南州'];
		$addressarr['青海省'] = ['不限', '西宁市', '海西州', '海东地区', '海北州', '果洛州', '玉树州', '黄南藏族自治州'];
		$addressarr['新疆维吾尔自治区'] = ['不限', '乌鲁木齐市', '伊犁州', '昌吉州', '石河子市', '哈密地区', '阿克苏地区', '巴音郭楞州', '喀什地区', '塔城地区', '克拉玛依市', '和田地区', '阿勒泰州', '吐鲁番地区', '阿拉尔市', '博尔塔拉州', '五家渠市', '克孜勒苏州', ' 图木舒克市'];
		$addressarr['西藏区'] = ['不限', '拉萨市', '山南地区', '林芝地区', '日喀则地区', '阿里地区', '昌都地区', '那曲地区'];
		$addressarr['吉林省'] = ['不限', '吉林市', '长春市', '白山市', '延边州', '白城市', '松原市', '辽源市', '通化市', '四平市'];
		$addressarr['宁夏回族自治区'] = ['不限', '银川市', '吴忠市', '中卫市', '石嘴山市', '固原市'];
		
		
		$catelist = ComjobsCateModel::field('id as value, title, priority')->order(['priority'=>'desc','id'=>'desc'])->select()->toArray();
		array_unshift( $catelist, array('value'=>0,'title'=>'不限') );
		$wtypelist = array(['value'=>0,'title'=>'不限'], ['value'=>1,'title'=>'月薪'], ['value'=>2,'title'=>'日薪'], ['value'=>3,'title'=>'时薪'], ['value'=>4,'title'=>'面议'] );
		
		$page = input('page/d',1);
		$map = array();
		$map[] = ['status','in','3,4'];
		$keywords = input('keywords/s', "");
		if (!empty($keywords)){
			$map[] =['title', 'like', '%'.$keywords.'%'];
		}
		$cateid = input('cateid/d', 0);
		if (!empty($cateid)){
			$map[] = ['cateid', '=', $cateid];
		}
		$wtype = input('wtype/d', 0);
		if (!empty($wtype)){
			$map[] = ['wtype', '=', $wtype];
		}
		$province = input('province/s', "");
		$province = empty($province) ? "不限" : $province;
		if ($province!="不限"){
			$map[] =['province', '=', $province];
		}
		$city = input('city/s', "");
		$city = empty($city) ? "不限" : $city;
		if ($city!="不限"){
			$map[] =['city', '=', $city];
		}
		$list = ComjobsModel::with(['worker','comjobsCate'])->where($map)->order(['priority'=>'desc','id'=>'desc',])->append(['wtype_text'])->page($page)->paginate(['list_rows'=>10,'query' => request()->param()]);
		$pageview = $list->render();
		return view('comjobs/comjobs', [
			'keywords'		=> $keywords,
			'cateid'		=> $cateid,
			'wtype'			=> $wtype,
			'province'		=> $province,
			'city'			=> $city,
			'catelist'		=> $catelist,
			'wtypelist'		=> $wtypelist,
			'addressarr'	=> $addressarr,
			'list'			=> $list,
			'pageview'		=> $pageview
		]);
	}
	
}
	